import os.path
import traceback

from bbcloud_autotest_sdk.poco_babybus.drivers.std import StdPoco
from bbcloud_autotest_sdk.public.common import act
from bbcloud_autotest_sdk.public.tools import get_mid_string, get_mid_string_num


class BasePage:
    poco: StdPoco

    def __init__(self, engine):
        self.adb_id = engine.app_id
        self.act = act(engine)
        self.poco = self.act.app_poco
        self.and_poco = engine.android_poco_obj

    def run_all(self):
        """
        运行该case下所有的测试用例
        """
        case_obj = self
        funcs = dir(case_obj)
        funcs = [x for x in funcs if 'case' in x]
        funcs.sort(key=lambda x: get_mid_string_num(x, "num_", "_"))
        for _item in funcs:
            if "case" in _item:
                print("%s 设备找到测试用例: %s 编号: %s" %
                      (self.adb_id, _item, get_mid_string(_item, "num_", "_")))
                eval("case_obj.%s()" % _item)


    def show_main(self):
        self.run_all()

