import os
import re
from time import sleep


def _perform_get_app_pid(adb_path, adb_id, apk_id):
    lines = os.popen(
        adb_path + " -s " + adb_id + ' shell  ps | grep ' + apk_id).readlines()  # 逐行读取
    for line in lines:
        if re.findall(apk_id, line):
            lis = line.split(" ")
            lis = list(filter(lambda x: x != '', lis))
            if lis[1]:
                APP_ID = lis[1]
            return lis[1]


def _perform_get_m3_flow(pid, adb_path, adb_id):
    getuid = os.popen(
        adb_path + " -s " + adb_id + ' shell cat /proc/' + pid + "/status |grep Uid").read()
    uid = re.findall('\d+', getuid)[0]
    data = os.popen(
        adb_path + " -s " + adb_id + " shell  cat /proc/net/xt_qtaguid/stats | grep " + uid).readlines()
    if data and len(data) != 0:
        lis = data[-1].split(" ")
        lis = list(filter(lambda x: x != '', lis))
        result = {
            'system_down_flow': int(lis[5].strip()) / 1024,
            'system_up_flow': int(lis[7].strip()) / 1024,
            'system_flow': (int(lis[5].strip()) + int(lis[7].strip())) / 1024
        }
    else:
        result = {
            'system_down_flow': 0,
            'system_up_flow': 0,
            'system_flow': 0
        }
    return result


pre_total_usage = None
pre_idle = None


def _perform_get_top_total_cpu(adb_path, adb_id):
    lines = os.popen(
        adb_path + " -s " + adb_id + ' shell  cat /proc/stat').readlines()
    current_total_usage = 0
    for val in lines[0].split()[1:]:
        current_total_usage += int(val)
    current_idle = lines[0].split()[4]
    global pre_total_usage, pre_idle
    if pre_total_usage is None:
        pre_total_usage = current_total_usage
        pre_idle = current_idle
        sleep(1)
        return _perform_get_top_total_cpu()

    cpu_total_time = current_total_usage - pre_total_usage
    cpu_idle_time = int(current_idle) - int(pre_idle)

    result = 100 * (cpu_total_time - cpu_idle_time) / cpu_total_time
    pre_total_usage = current_total_usage
    pre_idle = current_idle
    return round(result, 2)


def _perform_get_app_cpu(adb_path, adb_id, apk_id):
    lines = os.popen(
        adb_path + " -s " + adb_id + ' shell  top -n 1 ').readlines()  # 逐行读取
    cpu_index = 2
    need_find = True
    # 获取cpu序列
    for line in lines:
        if re.findall("CPU%", line):
            lis = line.split(" ")
            lis = list(filter(lambda x: x != '', lis))
            i = 0
            for item in lis:
                if item == "CPU%":
                    cpu_index = i
                    need_find = False
                i = i + 1
    if need_find:
        for line in lines:
            if re.findall("CPU", line):
                lis = line.split(" ")
                lis = list(filter(lambda x: x != '', lis))
                i = 0
                for item in lis:
                    if "CPU" in item:
                        cpu_index = i
                        break
                    i = i + 1
    for line in lines:
        # 过滤出app占用cpu
        if re.findall(apk_id + "\n", line):
            lis = line.split(" ")
            lis = list(filter(lambda x: x != '', lis))
            return lis[cpu_index].replace("%", "")
        elif re.findall("com.sinyee.baby\+" + "\n", line):
            lis = line.split(" ")
            lis = list(filter(lambda x: x != '', lis))
            return lis[cpu_index].replace('%', '')


ALL_MEM = None


def _perform_get_all_mem(adb_path, adb_id):
    global ALL_MEM
    if ALL_MEM:
        return ALL_MEM
    lines = os.popen(
        adb_path + ' -s ' + adb_id + ' shell cat /proc/meminfo').readlines()  # 逐行读取
    lis = []
    total = "MemTotal"
    for line in lines:
        if re.findall(total, line):
            lis = line.split(" ")
            lis = list(filter(lambda x: x != '', lis))
    if len(lis) > 0:
        ALL_MEM = int(lis[1])
        return ALL_MEM
    else:
        return 0


def _perform_get_app_mem(adb_path, adb_id, apk_id):
    lines = os.popen(
        adb_path + " -s " + adb_id + ' shell   dumpsys  meminfo').readlines()  # 逐行读取
    for line in lines:
        if re.findall(apk_id, line):
            lis = line.split(" ")
            lis = list(filter(lambda x: x != '', lis))
            if len(lis) > 0:
                return float((lis[0].replace(',', '').replace('K', '').replace(':', '')))
            else:
                return 0


def _perform_get_battery(adb_path, adb_id):
    lines = os.popen(
        adb_path + " -s " + adb_id + ' shell   dumpsys  battery | grep temperature').readlines()
    if re.findall(r'\d+', lines[0]):
        return int((re.findall(r'\d+', lines[0]))[0]) / 10
    else:
        return 0
